<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Task 48.10</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <!-- Select2 -->
  <link rel="stylesheet" href="plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  <!-- daterange picker -->
  <link rel="stylesheet" href="plugins/daterangepicker/daterangepicker.css">
  
</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">DevCamp 120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">LinhLT</a>
        </div>
      </div>

      <!-- SidebarSearch Form -->
      <div class="form-inline">
        <div class="input-group" data-widget="sidebar-search">
          <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
          <div class="input-group-append">
            <button class="btn btn-sidebar">
              <i class="fas fa-search fa-fw"></i>
            </button>
          </div>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="chartJs.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Quản lý bảng điểm</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="#" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Quản lý sinh viên</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="#" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Quản lý môn học</p>
                </a>
              </li>
            </ul>
          </li>
          
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Quản lý bảng điểm</h1>
          </div>
          
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container">
        <div class = "text-center mt-3">
            <h2>F200 - LỊCH SỬ HỌC TẬP</h2>
        </div>
        <div class = "container jumbotron">
            <div class="row">
              <label class = "col-sm-2 col-form-label">Sinh viên</label>
              <div class = "col-sm-3">
                <select id="select-student-filter" class = "form-control select2" style="width: 100%;">
                  <option selected="selected" value="all">(All)</option>
                  
                </select>
              </div>
              <label class = "col-sm-2 col-form-label">Môn học</label>
              <div class = "col-sm-3">
                <select selected="selected" id="select-subject-filter" class = "form-control select2" style="width: 100%;">
                  <option value="all">(All)</option>
                  
                </select>
              </div>
              <button class="btn btn-info col-sm-2" id="btn-filter-orders">Lọc dữ liệu</button>
            </div>
          </div>
        <div class = "form-group">
            <button class = "btn btn-success" id="btn-add-user"><i class="fa fa-plus"></i>&nbsp; Thêm</button>
        </div>
        
        <table id="grade-table" class="table table-bordered table-striped table-hover">
          <thead>
            <tr>
              <th>STT</th>
              <th>Sinh viên</th>
              <th>Môn học</th>
              <th>Điểm</th>
              <th>Ngày thi</th>
              <th>Action</th>
            </tr>
          </thead>
          <tbody>
            
          </tbody>
        </table>
    </div>
    <!-- Create grade modal-->
    <div id="create-grade-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Tạo mới dữ liệu điểm</h5>
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>
                <!-- Modal body - chứa form dữ liệu -->
                <div class="modal-body"> 
                    <form> <!-- form thiết kế như form bình thường, theo grid model -->
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Mã sinh viên</label>
                        <div class="col-sm-8">
                        <select class="form-control select2" style="width: 100%;" id="select-create-student-id">
                            <option selected="selected" value=0>(Chọn sinh viên)</option>
                            
                        </select>
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Mã môn học</label>
                        <div class="col-sm-8">
                        <select class="form-control select2" style="width: 100%;" id="select-create-subject-id">
                            <option selected="selected" value=0>(Chọn môn học)</option>
                            
                        </select>
                        </div>
                    </div>

                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Điểm</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-create-grade">
                        </div>
                    </div>

                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Ngày thi</label>
                        <div class="col-sm-8">
                          <!--<input class="form-control" id="input-create-exam-date">-->
                          <div class="input-group">
                            <div class="input-group-prepend">
                              <span class="input-group-text">
                                <i class="far fa-calendar-alt"></i>
                              </span>
                            </div>
                            <input type="text" class="form-control float-right" id="input-create-exam-date">
                          </div>
                      </div>
                    </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button type="button" id="btn-create-grade" class="btn btn-primary">Tạo mới</button>
                    <button type="button" id="btn-create-cancel" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                </div>
            </div>
        </div>
    </div>
    
    <!-- Edit grade modal-->
    <div id="edit-grade-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Chi tiết điểm</h5>
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>
                <!-- Modal body - chứa form dữ liệu -->
                <div class="modal-body"> 
                    <form> <!-- form thiết kế như form bình thường, theo grid model -->
                        <div class="row form-group">
                            <label class="col-sm-4 col-form-label">Sinh viên</label>
                            <div class="col-sm-8">
                              <select class="form-control select2" style="width: 100%;" id="select-edit-student-id">
                                <option selected="selected" value="">(chọn sinh viên)</option>
                              </select>
                            </div>
                        </div>
                        <div class="row form-group">
                            <label class="col-sm-4 col-form-label">Môn học</label>
                            <div class="col-sm-8">
                              <select class="form-control select2" style="width: 100%;" id="select-edit-subject-id">
                                <option selected="selected" value="">(chọn môn học)</option>
                              </select>
                            </div>
                        </div>
    
                        <div class="row form-group">
                            <label class="col-sm-4 col-form-label">Điểm</label>
                            <div class="col-sm-8">
                            <input class="form-control" id="input-edit-grade">
                            </div>
                        </div>
    
                        <div class="row form-group">
                            <label class="col-sm-4 col-form-label">Ngày thi</label>
                            <div class="col-sm-8">
                              <!--<input class="form-control" id="input-edit-exam-date">-->
                              <div class="input-group">
                                <div class="input-group-prepend">
                                  <span class="input-group-text">
                                    <i class="far fa-calendar-alt"></i>
                                  </span>
                                </div>
                                <input type="text" class="form-control float-right" id="input-edit-exam-date">
                              </div>
                            </div>
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button type="button" id="btn-update-grade" class="btn btn-success">Cập nhật điểm</button>
                    <button type="button" id="btn-update-cancel" class="btn btn-success" data-dismiss="modal">Hủy bỏ</button>
                </div>
            </div>
        </div>
    </div>

    <!-- Delete confirm modal -->
    <div>
        <div class="modal fade" tabindex="-1" id="delete-grade-modal">
        <div class="modal-dialog">
            <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="h5-modal-title">Confirm xóa dữ liệu điểm</h5>
                <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
                <label>Bạn có chắc chắn muốn xóa dữ liệu điểm này không?</label>
            </div>
            <div class="modal-footer">
                <button class="btn btn-danger" id="btn-confirm-delete-grade">Xác nhận</button>
                <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
            </div>
            </div>
        </div>
        </div>
    </div>

    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 1.0.0
    </div>
    <strong>Copyright &copy; 2023 <a href="">DevCamp 120</a>.</strong> All rights reserved.
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Select2 -->
<script src="plugins/select2/js/select2.full.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- InputMask -->
<script src="plugins/moment/moment.min.js"></script>
<script src="plugins/inputmask/jquery.inputmask.min.js"></script>
<!-- date-range-picker -->
<script src="plugins/daterangepicker/daterangepicker.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<script>
  $(function () {
    //Initialize Select2 Elements
    $('.select2').select2()

    //Initialize Select2 Elements
    $('.select2').select2({
      theme: 'bootstrap4'
    })
  })
  //Date picker
  $('#input-create-exam-date').daterangepicker({
        singleDatePicker: true, //<==HERE
    });
  $('#input-edit-exam-date').daterangepicker({
        singleDatePicker: true, //<==HERE
    });
</script>
<script>
  "use strict";
/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  const gBASE_URL = "https://62454a477701ec8f724fb923.mockapi.io/api/v1/";
  const gCONTENT_TYPE = "application/json";

  // Biến toàn cục để lưu trữ id grade đang đc update or delete. Mặc định = 0;
  var gGradeId = 0;
  var gGradeObj = {};
  var gStudentList;
  var gSubjectList;
  var gGradeList;

  // Biến mảng hằng số chứa danh sách tên các thuộc tính
  var gNameCol = ["stt", "studentId", "subjectId", "grade", "examDate", "action"];
  // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
  const gSTT_COL = 0;
  const gSTUDENT_COL = 1;
  const gSUBJECT_COL = 2;
  const gGRADE_COL = 3;
  const gEXAM_DATE_COL = 4;
  const gACTION_COL = 5;
  var gStt = 0;
  var gGradeTable =  $("#grade-table").DataTable({
      columns: [
        {data: gNameCol[gSTT_COL]},
        {data: gNameCol[gSTUDENT_COL]},
        {data: gNameCol[gSUBJECT_COL]},
        {data: gNameCol[gGRADE_COL]},
        {data: gNameCol[gEXAM_DATE_COL]},
        {data: gNameCol[gACTION_COL]}
          ],
      columnDefs: [ //định nghĩa các cột hiển thị
          { 
          targets: gSTT_COL,
          render: renderStt
          },
          { 
          targets: gSTUDENT_COL,
          render: renderStudentIdToStudentName
          },
          { 
          targets: gSUBJECT_COL,
          render: renderSubjectIdToSubjectName
          },    
          { 
          targets: gACTION_COL,
          className: "text-center", 
          defaultContent: `
          <img class="edit-grade" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
          <img class="delete-grade" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
          `
          },
      ]
    });
/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
$(document).ready(function(){
  onPageLoading();
});
//gán sự kiện cho nút filter
$("#btn-filter-orders").click(function(){
    onBtnFilterDataClick();
  })
//2-C: gán sự kiện thêm mới
$("#btn-add-user").on("click",function(){
  onBtnAddNewGradeClick(this);
});
//gán sự kiện cho các nút trên create user modal
$("#btn-create-grade").on("click",function(){
  onBtnCreateGradeClick(this);
});

//3-U: gán sự kiện sửa
$("#grade-table").on("click",".edit-grade",function(){
  onBtnEditGradeClick(this);
});
//gán sự kiện cho các nút trên update grade modal
$("#btn-update-grade").on("click",function(){
  onBtnUpdateGradeClick(this);
});

//4-D: gán sự kiện nút xóa 
$("#grade-table").on("click",".delete-grade",function(){
  onBtnDeleteGradeClick(this);
});
//gán sự kiện cho nút xác nhận xóa user modal
$("#btn-confirm-delete-grade").on("click",function(){
  onBtnConfirmDeleteGradeClick(this);
});

/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
function onPageLoading(){
  //1-R: Read /Load grade to data table
  getAllStudents();
  getAllSubjects();
  getAllGrades();
}
//hàm xử lý nút sự kiện filter click
function onBtnFilterDataClick(){
    var vFilterObj = {
      student:"",
      subject: ""
    };
    //b1: thu thập dữ liệu
    thuThapDuLieuFilter(vFilterObj);
    //b2: validate(không có)
    //b3: filter order
    var vFilterResult = filterOrders(vFilterObj);

    //b4: hiển thị dữ liệu sau khi lọc
    loadDataToGradeTable(vFilterResult);
  }
//hàm xử lý sự kiện ấn icon edit grade
function onBtnEditGradeClick(paramBtnEdit){
  //lưu thông tin grade id vào biến toàn cục
  gGradeId = getGradeIdFromButton(paramBtnEdit);
  console.log("Id của dữ liệu điểm tương ứng: " + gGradeId);
  //hiển thị modal lên
  $("#edit-grade-modal").modal("show");
  loadGradeDataToGradeEditModal(gGradeObj);
}
//hàm xử lý sự kiện ấn icon delete grade
function onBtnDeleteGradeClick(paramBtnDelete){
  $("#delete-grade-modal").modal("show");
  //lưu thông tin grade id vào biến toàn cục
  gGradeId = getGradeIdFromButton(paramBtnDelete);
  console.log("Id của dữ liệu điểm tương ứng: " + gGradeId);
}
//hàm xử lý sự kiện ấn nút add grade
function onBtnAddNewGradeClick(){
 //hiển thị modal lên
 $("#create-grade-modal").modal("show");
}
//hàm xử lý sự kiện nhấn nút create grade trên modal
function onBtnCreateGradeClick(){
  //khai báo đối tượng grade obj
  var vObjectRequestData = {
      studentId:"",
      subjectId: "",
      grade: "",
      examDate: ""
  }
  //b1: thu thập dữ liệu input trên modal
  getInsertGradeData(vObjectRequestData);
  //b2: validate
  var vIsValid = validateGradeData(vObjectRequestData);
  //b3: gọi API thêm grade
  if(vIsValid){
      ajaxCreateGrade(vObjectRequestData);
  };
}
//hàm xử lý sự kiện nhấn nút update user trên modal
function onBtnUpdateGradeClick(){
  //khai báo đối tượng grade obj
  var vObjectRequestData = {
      studentId:"",
      subjectId: "",
      grade: "",
      examDate: ""
  }
  //b1: thu thập dữ liệu input trên modal
  getEditedGradeData(vObjectRequestData);
  //b2: validate
  var vIsValid = validateGradeData(vObjectRequestData);
  //b3: gọi API thêm user
  if(vIsValid){
      ajaxUpdateGrade(vObjectRequestData);
  };
}

//hàm xử lý sự kiện xác nhận xóa user
function onBtnConfirmDeleteGradeClick(){
  "use strict";
  //gọi API xóa user
  ajaxDeleteGrade(gGradeId);
}
/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  //hàm render số thứ tư
  function renderStt(){
      gStt++;
      return gStt;
  }
  //hàm render Student Name theo student id
  function renderStudentIdToStudentName(paramStudentId){
    "use strict";
    var vStudentName = "NO_NAME";
    var vFound = false;
    var vViTriHienTai = 0;
    while (!vFound && vViTriHienTai < gStudentList.length){
      if (gStudentList[vViTriHienTai].id.toString() === paramStudentId.toString()){
        vStudentName = gStudentList[vViTriHienTai].lastname + " " + gStudentList[vViTriHienTai].firstname;
        vFound = true;
      }
      vViTriHienTai ++;
      }
    return vStudentName;
  }
  //hàm render Subject Name theo Subject id
  function renderSubjectIdToSubjectName(paramSubjectId){
    "use strict";
    var vSubjectName = "NO_NAME";
    var vFound = false;
    var vViTriHienTai = 0;
    while (!vFound && vViTriHienTai < gSubjectList.length){
      if (gSubjectList[vViTriHienTai].id.toString() === paramSubjectId.toString()){
        vSubjectName = gSubjectList[vViTriHienTai].subjectName;
        vFound = true;
      }
      vViTriHienTai ++;
      }
    return vSubjectName;
  }
  //load users to data table
  function loadDataToGradeTable(paramGrades){
      gGradeTable.clear();
      gGradeTable.rows.add(paramGrades);
      gGradeTable.draw();
  }
   //đọc thông tin dùng để lọc
   function thuThapDuLieuFilter(paramFilterObj){
    paramFilterObj.student = $("#select-student-filter").val();
    paramFilterObj.subject = $("#select-subject-filter").val();
  }
  //hàm lọc theo Filter Object
  function filterOrders(paramFilterObj){
    var vGrades = [];
    vGrades = gGradeList.filter(function(paramGrade){
      return ((paramGrade.studentId == paramFilterObj.student || paramFilterObj.student == "all") 
      && (paramGrade.subjectId == paramFilterObj.subject|| paramFilterObj.subject == "all"));
    });
    return vGrades;
  }
  //gọi API load all grades
  function getAllGrades() {
      $.ajax({
          url: gBASE_URL + "/grades",
          type: "GET",
          success: function(paramGrades){
              console.log(paramGrades);
              gGradeList = paramGrades;
              loadDataToGradeTable(paramGrades);
          },
          error: function(paramErr){
              console.log(paramErr.status);
          }
      });
      return gGradeList;
  }
  //gọi API lấy danh sách sinh viên
  function getAllStudents(){
      $.ajax({
          url: gBASE_URL + "/students",
          type: "GET",
          async: false,
          success: function(paramStudents){
              console.log(paramStudents);
              gStudentList = paramStudents;
              handleStudentList(paramStudents);
          },
          error: function(paramErr){
              console.log(paramErr.status);
          }
      });
      return gStudentList;
  }
  //gọi API lấy danh sách môn học
  function getAllSubjects(){
      $.ajax({
          url: gBASE_URL + "/subjects",
          type: "GET",
          async: false,
          success: function(paramSubjects){
              console.log(paramSubjects);
              gSubjectList = paramSubjects;
              handleSubjectList(paramSubjects);
          },
          error: function(paramErr){
              console.log(paramErr.status);
          }
      });
      return gSubjectList;
  }
  //hàm load option cho student select element
  function handleStudentList(paramStudents){
    "use strict";
    var vArrayStudentList = paramStudents;
    //load data to student select filter
    var vSelectStudent = document.getElementById("select-student-filter");
    for (var bI = 0; bI < vArrayStudentList.length; bI++){
      var vStudentOption = document.createElement("option");
      vStudentOption.value = vArrayStudentList[bI].id;
      vStudentOption.text =  vArrayStudentList[bI].lastname + " " + vArrayStudentList[bI].firstname;
      //thêm obtion cho filter
      vSelectStudent.appendChild(vStudentOption);
    }
    //load data to student select create
    var vCreateStudent = document.getElementById("select-create-student-id");
    for (var bIndex = 0; bIndex < vArrayStudentList.length; bIndex++){
      var vStudentOption = document.createElement("option");
      vStudentOption.value = vArrayStudentList[bIndex].id;
      vStudentOption.text =  vArrayStudentList[bIndex].lastname + " " + vArrayStudentList[bIndex].firstname;
      //thêm option trên modal
      vCreateStudent.appendChild(vStudentOption);
    }
    //load data to student select edit
    var vEditStudent = document.getElementById("select-edit-student-id");
    for (var i = 0; i < vArrayStudentList.length; i++){
      var vStudentOption = document.createElement("option");
      vStudentOption.value = vArrayStudentList[i].id;
      vStudentOption.text =  vArrayStudentList[i].lastname + " " + vArrayStudentList[i].firstname;
      //thêm option trên modal
      vEditStudent.appendChild(vStudentOption);
    }
  }
  //hàm load option cho subject select element
  function handleSubjectList(paramSubjects){
    "use strict";
    var vArraySubjectList = paramSubjects;
    //load data to subject select filter
    var vSelectSubject = document.getElementById("select-subject-filter");
    for (var bI = 0; bI < vArraySubjectList.length; bI++){
      var vSubjectOption = document.createElement("option");
      vSubjectOption.value = vArraySubjectList[bI].id;
      vSubjectOption.text =  vArraySubjectList[bI].subjectName;
      //thêm obtion cho filter
      vSelectSubject.appendChild(vSubjectOption);
    }
    //load data to subject select Create
    var vCreateSubject = document.getElementById("select-create-subject-id");
    for (var bIndex = 0; bIndex < vArraySubjectList.length; bIndex++){
      var vSubjectOption = document.createElement("option");
      vSubjectOption.value = vArraySubjectList[bIndex].id;
      vSubjectOption.text =  vArraySubjectList[bIndex].subjectName;
      //thêm option trên modal
      vCreateSubject.appendChild(vSubjectOption);
    }
    //load data to subject select edit
    var vEditSubject = document.getElementById("select-edit-subject-id");
    for (var i = 0; i < vArraySubjectList.length; i++){
      var vSubjectOption = document.createElement("option");
      vSubjectOption.value = vArraySubjectList[i].id;
      vSubjectOption.text =  vArraySubjectList[i].subjectName;
      //thêm option trên modal
      vEditSubject.appendChild(vSubjectOption);
    }
  }
  //hàm xác định grade id từ button
  function getGradeIdFromButton(paramButton){
      var vTableRow = $(paramButton).parents("tr");
      var vGradeRowData = gGradeTable.row(vTableRow).data();
      gGradeObj = vGradeRowData;
      return vGradeRowData.id;
  }
  //hàm đọc thông tin user data được thêm
  function getInsertGradeData(paramGradeObj){
      paramGradeObj.studentId = $("#select-create-student-id").val();
      paramGradeObj.subjectId = $("#select-create-subject-id").val();
      paramGradeObj.grade = $("#input-create-grade").val();
      paramGradeObj.examDate = $("#input-create-exam-date").val();
  }
  //hàm load thông tin grade ban đầu lên modal
  function loadGradeDataToGradeEditModal(paramGradeObj){
      $("#select-edit-student-id").val(paramGradeObj.studentId);
      $("#select-edit-subject-id").val(paramGradeObj.subjectId);
      $("#input-edit-grade").val(paramGradeObj.grade);
      $("#input-edit-exam-date").val(paramGradeObj.examDate);
  }
  //hàm đọc thông tin grade data được edited
  function getEditedGradeData(paramGradeObj){
      paramGradeObj.studentId = $("#select-edit-student-id").val();
      paramGradeObj.subjectId = $("#select-edit-subject-id").val();
      paramGradeObj.grade = $("#input-edit-grade").val().trim();
      paramGradeObj.examDate = $("#input-edit-exam-date").val();
  }
  //hàm validate grade data
  function validateGradeData(paramGradeObj){
      if (paramGradeObj.studentId == 0 ||
      paramGradeObj.subjectId == 0 ||
      paramGradeObj.grade == "" ||
      paramGradeObj.examDate == ""){
          alert("Cần nhập đầy đủ thông tin");
          return false;
      }
      return true;
  }
  //API thêm grade
  function ajaxCreateGrade(paramGradeRequest){
      "use strict";
      $.ajax({
          url: gBASE_URL + "/grades",
          type: "POST",
          contentType: gCONTENT_TYPE,
          data: JSON.stringify(paramGradeRequest),
          success: function(paramRes){
              console.log(paramRes);
              //b4: xử lý hiển thị
              handleCreateGradeSuccess();
          },
          error: function(paramErr){
              console.log(paramErr.status);
          }
      });
  }
  //hàm xử lý hiển thị khi thêm grade mới thành công
  function handleCreateGradeSuccess(){
      alert("Thêm dữ liệu điểm thành công!");
      //reload data on table
      getAllGrades();
      resetGradeForm();
      $("#create-grade-modal").modal("hide");
  }
  //hàm xóa thông tin trên form create grade modal
  function resetGradeForm(){
      $("#select-create-student-id").val("");
      $("#select-create-subject-id").val("");
      $("#input-create-grade").val("");
      $("#select-create-exam-date").val("");
          
  };
  //API update grade
  function ajaxUpdateGrade(paramGradeRequest){
      "use strict";
      $.ajax({
          url:  gBASE_URL + "/grades/" + gGradeId,
          type: "PUT",
          contentType: gCONTENT_TYPE,
          data: JSON.stringify(paramGradeRequest),
          success: function(paramRes){
              console.log(paramRes);
              //b4: xử lý hiển thị
              handleUpdateGradeSuccess();
          },
          error: function(paramErr){
              console.log(paramErr.status);
          }
      });
  }
  //hàm xử lý hiển thị khi user cập nhật thành công
  function handleUpdateGradeSuccess(){
      alert("Cập nhật điểm thành công!");
      //reload data on table
      getAllGrades();
      $("#edit-grade-modal").modal("hide");
  }
  //API delete user
  function ajaxDeleteGrade(paramUserId){
      "use strict";
      $.ajax({
          url:  gBASE_URL + "/grades/" + gGradeId,
          type: "DELETE",
          success: function(paramRes){
              console.log(paramRes);
              //b4: xử lý hiển thị
              handleDeleteGradeSuccess();
          },
          error: function(paramErr){
              console.log(paramErr.status);
          }
      });
  }
  //hàm xử lý hiển thị khi xóa dữ liêu điểm thành công
  function handleDeleteGradeSuccess(){
      alert("Xóa dữ liệu điểm thành công!");
      //reload data on table
      getAllGrades();
      $("#delete-grade-modal").modal("hide");
  }
</script>
</body>
</html>
